#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <time.h>
#include <syslog.h>
#include <sys/soundcard.h>

extern char *basename();

#define HTTP_REPLY	"HTTP/1.0 200 OK\r\nDate: %sExpires: %sPragma: no-cache\r\nContent-Type: audio/ulaw\r\n\r\n"

#define MAXREQ				1024
#define BUF_SIZE			1024

static char http_request[MAXREQ];

/* Lecture de la requte HTTP du client */
int get_http_request (int fd, char *request, int max_length)
{
  char end, c, last_char;
  int length = 0;

  end = 0;
  c = last_char = 0;

  while (!end) {

    if (read (fd, &c, 1) < 0)
      return -1;

    /* Test de fin de commande */
    if (c == '\r' && last_char == '\n') {
      if (read (fd, &c, 1) < 0)
	return -1;
      if (c == '\n')
	end = 1;
      else {
	syslog (LOG_ERR, "get_http_request: bad end of request!\n");

	return -1;
      }
    }
    else {
      if (request)
	*(request+length) = c;
      if (length < max_length-1)
	length++;
      /* Dpassement de taille de requte ou pas de marqueur de fin */
      else {
	syslog (LOG_ERR, "get_http_request: request too long!\n");
	return -1;
      }
    }

    last_char = c;
  }

  if (request)
    *(request+length) = 0;

  return length;
}

/* Dialogue HTTPD  ? */
static void http_dialog (int fd_in, int fd_out)
{
  int n;
  time_t t = time(0);
  struct tm *tm = localtime (&t);
  char http_header[1024], *asct;

  /* Lecture header */
  /*  if ((n = get_http_request (fd_in, http_request, sizeof(http_request))) <= 0)
    return;*/

  asct = asctime(tm);
  sprintf (http_header, HTTP_REPLY, asct, asct);

  /* Envoi du header HTTP */
  write (fd_out, http_header, strlen(http_header));
}


main (int ac, char **av)
{
  int n, nleft, nwritten, fd_audio;
  char buf[BUF_SIZE], *p, *progname = basename(av[0]);

  openlog (progname, LOG_PID | LOG_CONS, LOG_DAEMON);

  if ((fd_audio = open ("/dev/audio", O_RDONLY)) < 0) {
    syslog (LOG_ERR, "Can't open audio device, exiting.\n");
    exit (1);
  }

  /* Dialogue HTTP */
  http_dialog (0, 1);

  while ((n = read (fd_audio, buf, sizeof(buf))) > 0) {
    nleft = n;
    p = buf;

    /* On envoit l'chantillon... */
    while (nleft) {
      if ((nwritten = write (1, p, nleft)) < 0) {
	syslog (LOG_ERR, "/dev/audio: %m");
	exit (1);
      }

      nleft -= nwritten;
      p += nwritten;
    }
  }

  close (fd_audio);
}
