#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/soundcard.h>

static char *dev_names[] =  SOUND_DEVICE_NAMES;

main (int ac, char **av)
{
  int fd_mixer, mask, i;

  if (ac == 1) {
    fprintf (stderr, "Usage: %s device\n", av[0]);
    exit (1);
  }

  if ((fd_mixer = open ("/dev/mixer", O_RDWR)) < 0) {
    perror ("/dev/mixer");
    exit (1);
  }

  mask = 0;
  for (i = 0 ; i < SOUND_MIXER_NRDEVICES ; i++) {
    if (!strcmp (av[1], dev_names[i])) {
	mask |= (1 << i);
	break;
    }
  }

  if (!mask) {
    fprintf (stderr, "Device %s inconnu !\n", av[1]);
    close (fd_mixer);
    exit (1);
  }

  printf ("mask= %x\n", mask);

  if (ioctl (fd_mixer, SOUND_MIXER_WRITE_RECSRC, &mask) == -1) {
    perror ("ioctl");
  }

  close (fd_mixer);
}
